#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 



##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "set_filter") { &set_filter; }


##################################################################################

sub set_filter
{

$list_per_page = $q->param('list_per_page');
$filter = $q->param('filter');

open (FF, "> $data_dir/prembr.dat");
	print FF $list_per_page . "\n";
	print FF $filter . "\n";
close (FF);

&start;

}





sub start
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$dispdata = acs::get_file_contents("$data_dir/prembr.dat");
@dispd = split (/\n/, $dispdata);

$now = time;


	if (($dispd[1] eq "") or ($dispd[1] eq "all"))
		{
		$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*
		FROM dirs AS B, links AS A
		WHERE (A.cid = B.cid) AND (((A.subs_expire != '') AND (A.subs_expire IS NOT NULL)) OR (A.premium > '0'))";
		$all_sel = "selected";
		}
		elsif ($dispd[1] eq "premium")
		{
		$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*
		FROM dirs AS B, links AS A
		WHERE (A.cid = B.cid) AND (A.premium > '0') AND ((subs_expire > '$now') OR (subs_expire IS NULL) OR (subs_expire = ''))";		
		$premium_sel = "selected";
		}
		elsif ($dispd[1] eq "expired")
		{
		$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*
		FROM dirs AS B, links AS A
		WHERE (A.cid = B.cid) AND ((subs_expire < '$now') AND (subs_expire IS NOT NULL) AND (subs_expire != ''))";
		$expired_sel = "selected";
		}
		elsif ($dispd[1] eq "never")
		{
		$sql = "SELECT B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.cid, A.*
		FROM dirs AS B, links AS A
		WHERE (A.cid = B.cid) AND (A.premium > '0') AND ((subs_expire IS NULL) OR (subs_expire = ''))";				
		$never_sel = "selected";
		}
		

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();


### PREPARE PAGES

$icnt = $rows;

$nr_searchres = $dispd[0];
if ($nr_searchres < 1) { $nr_searchres = 10; }
		
		if ($nr_searchres eq "10") { $s10 = "selected"; }
		if ($nr_searchres eq "20") { $s20 = "selected"; }
		if ($nr_searchres eq "30") { $s30 = "selected"; }
		if ($nr_searchres eq "50") { $s50 = "selected"; }
		if ($nr_searchres eq "70") { $s70 = "selected"; }
		if ($nr_searchres eq "100") { $s100 = "selected"; }
		if ($nr_searchres eq "200") { $s200 = "selected"; }
		if ($nr_searchres eq "500") { $s500 = "selected"; }
		

### IF NOTHING TO DISPLAY
if ($rows < 1)
	{


$hbox = acs::get_heading_box("$web_url/ic_premium.gif", "Browse/Edit Premium Links", qq[
This email is sent to users requesting their passwords to modify links.<BR>
<a href="$admin_url/admin23.cgi?fct=prem_main">Premium Link Manager</a> &gt;&gt; Browse/Edit Premium Links</font>

<form method="POST" action="$admin_url/admin66.cgi">
      <input type="hidden" name="fct" value="set_filter"><p><select name="list_per_page"
      size="1" style="font-family: MS Sans Serif; font-size: 8">
        <option value="10" $s10>List 10 Links Per Page</option>
        <option value="20" $s20>List 20 Links Per Page</option>
        <option value="30" $s30>List 30 Links Per Page</option>
        <option value="50" $s50>List 50 Links Per Page</option>
        <option value="70" $s70>List 70 Links Per Page</option>
        <option value="100" $s100>List 100 Links Per Page</option>
        <option value="200" $s200>List 200 Links Per Page</option>
        <option value="500" $s500>List 500 Links Per Page</option>
      </select> <select name="filter" size="1" style="font-family: MS Sans Serif; font-size: 8">
        <option value="all" $all_sel>No Filter (Show All)</option>
        <option value="premium" $premium_sel>Show Active Premium Links Only</option>
        <option value="expired" $expired_sel>Show Expired Premium Links Only</option>
        <option value="never" $never_sel>Show Premium Links That Never Expires</option>
      </select> <input type="submit" value="  Go   " name="B1"
      style="font-family: MS Sans Serif; font-size: 8"></p>
    </form>
]); 

print qq[
<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>

<body>
$hbox

<ul>
  <li>
    No links found.
  </li>
</ul>

</body>
</html>
];
exit;
	
	}
	
### GET EXTRA KEYS/FIELDS 

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;
	
	

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$ippc = 1;
$form_c_counter = 0;
$c_counter = 0;

	while ( @row = $sth->fetchrow() )
		{
		if (($ippc > $st) and ($ippc <= $nd))
	    {				
				$printcrit = "";
				
				### GET CATEGORY
				$cats = "";
				for ($ms = 0; $ms < 16; $ms++) 
					{
					if ($row[$ms] ne "")
						{
						$cats = $cats . $row[$ms] . "/";
						}
					}


				### CHECKBOX
				$cbname = "C" . $c_counter;
				$cb_val = $row[17] . "-" . $row[16];
				$cbox = "<input type=\"checkbox\" name=\"$cbname\" value=\"$cb_val\">";
				$c_counter++;
				
				
				### CHECK IF LINK IS A PREMIUM LINK OR EXPIRED LINK
				### $row[38] = subs_expire 
				### $row[30] = premium
				
				$expdate = acs::decode_date($row[38]);
				
				#if (($row[38] == 0) and ($row[30] > 0))
				#{ $row[38] = 99999999999999; }

				$premimg = ""; $expires = "";
				if (($row[30] > 0) and ($row[38] > $nowtime))### IF PREMIUM LINK
					{
					$expires = qq[<BR><font color="#0000A0"><b>Expires: $expdate</b></font>];
					}
			elsif (($row[30] == 0) and ($row[38] > 0)) ### IF EXPIRED
					{
					$expires = qq[<BR><font color="#FF0000"><b>Expired: $expdate</b></font>];
					}
			elsif (($row[30] > 0) and ($row[38] < 1)) ### IF NEVER EXPIRES
					{
					$expires = qq[<BR><font color="#FF0000"><b>Never Expires</b></font>];
					}
				
			
			$printcrit = $printcrit . "<b>$ippc. $premimg<a href=\"$row[22]\" target=\"_blank\">$row[19]</a></b><BR>";
			$printcrit = $printcrit .  "$row[20]<BR>";
			$printcrit = $printcrit .  "<b>$row[22]</b><BR>";
				

			#### EXTRA KEYS/FIELDS
			$field_key_count = 44;
			foreach $kitem (@akeys)
				{
				($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
		
				if (($nmbr eq "Upload") and ($visible eq "Yes"))
					{
						if ($row[$field_key_count] ne "")
							{
							$e_imagelink = "$web_url/imagefiles/$row[17]/$keyname" . "." .  $row[$field_key_count];
							$printcrit = $printcrit .  qq[<b><font color="#804040">$description:</font></b> <a href="$e_imagelink" target="_blank">$e_imagelink</a><br>];
							}
							else
							{
							$printcrit = $printcrit .  qq[<b><font color="#804040">$description:</font></b> $na<br>];
							}
					}				
					elsif (($visible eq "Yes") and ($imgk ne "Yes"))
					{
							$printcrit = $printcrit .  "<b><font color=\"#8080C0\">$description:</font></b> $row[$field_key_count]<br>";
					}
					elsif (($imgk eq "Yes") and ($visible eq "Yes"))
					{
						if ($row[$field_key_count] ne "")
							{
							$printcrit = $printcrit .  "<img src=\"$row[$field_key_count]\"><br>";
							}
					}
					
				$field_key_count++;
				}
		
			
			#### GET CATEGORY
			$ecat = "";
			@acts = split (/\//, $cats);
			foreach $citem (@acts)
				{
				$ecat = $ecat . acs::encode_dir($citem) . "-";
				}
			chop($ecat);

			$printcrit = $printcrit . "<b>ID: $row[17]</b>$expires<BR>";

			$printcrit = $printcrit .  "<img src=\"$web_url/dir.gif\"> <a href=\"$admin_url/admin12.cgi?ct=$ecat&fct=gotocat&cid=$row[18]&C0=$row[17]\" 
			onClick=\"self.opener.location='$admin_url/admin12.cgi?ct=$ecat&fct=gotocat&cid=$row[18]&C0=$row[17]'; self.opener.focus(); return false;\">From: $cats</a><BR>";
						
			
			### IF USER ACCOUNT EXISTS FOR LINK
			$user_account_jump = "";
			if ($row[33] > 0) 
				{
				$user_account_jump = qq[<b>[<a href="$admin_url/admin55.cgi?fct=editacc&userid=$row[33]" onClick="popup('$admin_url/admin55.cgi?fct=editacc&userid=$row[33]',750,600);return false;">User Account</a>]</b>];
				}
			
			
$printcrit = $printcrit . qq[
[<a href="$admin_url/admin12.cgi?ct=$ecat&fct=Edit&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Edit&cid=$row[18]&C0=$row[17]',screen.width-250,screen.height-250);return false;">Edit</a>] 
[<a href="$admin_url/admin12.cgi?ct=$ecat&fct=Move&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Move&cid=$row[18]&C0=$row[17]',screen.width-250,screen.height-250);return false;">Move</a>] 
[<a href="$admin_url/admin12.cgi?ct=$ecat&fct=Copy&cid=$row[18]&C0=$row[17]" onClick="popup('$admin_url/admin12.cgi?ct=$ecat&fct=Copy&cid=$row[18]&C0=$row[17]',screen.width-250,screen.height-250);return false;">Copy</a>]
];

		$scroe = $row[44 + $knr];
		$printcrit = $printcrit .  "[<a href=\"$admin_url/admin12.cgi?ct=$ecat&fct=Delete&cid=$row[18]&C0=$row[17]&del_only_one=true\" onClick=\"popup('$admin_url/admin12.cgi?ct=$ecat&fct=Delete&cid=$row[18]&C0=$row[17]&del_only_one=true',600,400);return false;\">Delete</a>] $user_account_jump<Br>";
		$printcrit = $printcrit .  $relg;


$all_links = $all_links . qq[
<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="3%" valign="top"></td>
    <td width="1%" valign="top">$cbox</td>
    <td width="99%" class="normaltext">$printcrit</td>
  </tr>
</table>

<BR>
];		

 		$form_c_counter++;	
		}
     
		$ippc++;
		}

$sth->finish;
$dbh->disconnect;




#### PAGES 
$fct= $q->param('fct');

for ($ms = 0; $ms < $pages; $ms++) 
	{
	$pg = $ms + 1;
	if ($nd == ($pg * $nr_searchres))
		{
		$pgstring = $pgstring . " [$pg] ";
		$targpage = $pg;
		}
	  	else
		{
		$st1 = ($pg * $nr_searchres) - $nr_searchres;
		$nd1 = ($pg * $nr_searchres);
		
		
		$pgstring = $pgstring . "<a href=\"$admin_url/admin66.cgi?st=$st1&nd=$nd1\">$pg</a> ";
		}
	}

if ($pages > 1)
	{
	$pgstring = "Pages: " . $pgstring;
	}
	else
	{
	$pgstring = "";
	}





### PREV NEXT PAGES

$spls = $modp;
if ($spls == 0){$spls++;}

 if ($nd <= ($icnt - $spls))
 	{
	$st1 = $st + $nr_searchres;
	$nd1 = $nd + $nr_searchres;
	$nextt = "<a href=\"$admin_url/admin66.cgi?st=$st1&nd=$nd1\">Next Page >></a> ";
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		$prev = "<a href=\"$admin_url/admin66.cgi?st=$st1&nd=$nd1\"><< Prev Page</a> ";
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}

if ($rows > 0)
	{
	$page_crit = $page_crit . "$prevnext $myspacer Page $targpage of $pg | ";
	}


for ($ms = 0; $ms < $form_c_counter; $ms++) 
	{
	$sel_options = $sel_options . "'C" . $ms . "',";
	}
	$sel_options = substr($sel_options, 0, length($sel_optionss) - 1);






$hbox = acs::get_heading_box("$web_url/ic_premium.gif", "Browse/Edit Premium Links", qq[
This email is sent to users requesting their passwords to modify links.<BR><BR>
<b><a href="$admin_url/admin23.cgi?fct=prem_main">Premium Link Manager</a> &gt;&gt; Browse/Edit Premium Links</b>

<form method="POST" action="$admin_url/admin66.cgi">
      <input type="hidden" name="fct" value="set_filter"><p><select name="list_per_page"
      size="1" style="font-family: MS Sans Serif; font-size: 8">
        
        <option value="10" $s10>List 10 Links Per Page</option>
        <option value="20" $s20>List 20 Links Per Page</option>
        <option value="30" $s30>List 30 Links Per Page</option>
        <option value="50" $s50>List 50 Links Per Page</option>
        <option value="70" $s70>List 70 Links Per Page</option>
        <option value="100" $s100>List 100 Links Per Page</option>
        <option value="200" $s200>List 200 Links Per Page</option>
        <option value="500" $s500>List 500 Links Per Page</option>
        
      </select> <select name="filter" size="1" style="font-family: MS Sans Serif; font-size: 8">
        <option value="all" $all_sel>No Filter (Show All)</option>
        <option value="premium" $premium_sel>Show Active Premium Links Only</option>
        <option value="expired" $expired_sel>Show Expired Premium Links Only</option>
        <option value="never" $never_sel>Show Premium Links That Never Expires</option>
      </select> <input type="submit" value="  Go   " name="B1"
      style="font-family: MS Sans Serif; font-size: 8"></p>
    </form>
]); 



print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
<script LANGUAGE="JavaScript">
<!-- Hide
var popupwin = null;
  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
      if (popupwin == null || popupwin.closed)
			{
            popupwin = window.open (loc, 'popupwin', myspecs);
           }
		 else
		   {
            popupwin.focus();
            popupwin.location.href = loc;
          }
    }


function checkall(formname,thestate)
	{
	BoxNames=new Array($sel_options)
	for (c=0;c < BoxNames.length; c++)
		{
		boxname = eval("document." + formname + "." + BoxNames[c])
		boxname.checked = thestate
		}
	}


function submitForm(theForm, selv) 
  {
  BoxNames=new Array($sel_options)
  windowName = "PowerSeek";
  windowURL = theForm.action + '?';
  var c = 0;
	for (c=0;c < BoxNames.length; c++)
		{
		chvl = eval("theForm." + BoxNames[c] + ".checked");
		if (chvl)
			{
			boxnm = eval("theForm." + BoxNames[c] + ".value");
			windowURL = windowURL + BoxNames[c] + '=' + boxnm + '&';
			}
		}
    windowURL = windowURL + 'itemnrs=$form_c_counter&';
    
    if (selv == 1)
    	{
    	windowURL = windowURL + 'dropdown=' + theForm.dropdown1.value;
    	}
    	else
    	{
    	windowURL = windowURL + 'dropdown=' + theForm.dropdown.value;
    	}
    
    var myspecs = 'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,' + 'width=' + (screen.width-250) + ',height=' + (screen.height-250);
    var popupwin = null;
    
    var random = parseInt(Math.random()*10000)
    
    myWindow = window.open(windowURL, 'popupwin' + random, myspecs);
    myWindow.focus();
  } 

// End Hide -->
</script>

</head>
<body>

$hbox


<form name="select_all" method="POST" action="$admin_url/admin56.cgi">
<input type="hidden" name="itemnrs" value="$c_counter">

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="100%" class="normaltext">Number of Matches (Premium Links): <strong>$rows </strong><br>
      <br>
    $page_crit $pgstring <br>
    <br>
    <select name="dropdown1" size="1" style="font-family: MS Sans Serif; font-size: 8pt">
      <option value="Edit"> Edit Checked Items </option>
      <option value="Move"> Move Checked Items </option>
      <option value="Copy"> Copy Checked Items </option>
      <option value="Delete"> Delete Checked Items </option>
    </select> 
    <input type="submit" value="Submit" name="B1"
    style="font-family: MS Sans Serif; font-size: 8pt"
    onClick="submitForm(document.select_all,1); return false;"> 
    <a
    href="javascript:checkall('select_all',true)">Check All </a>| <a
    href="javascript:checkall('select_all',false)">UnCheck All </a></td>
  </tr>
</table>

<hr size="1" color="#E8E8E8">

$all_links

<hr noshade size="1" color="#F2F2F2">
<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="100%" class="normaltext"><select name="dropdown" size="1"
    style="font-family: MS Sans Serif; font-size: 8pt">
      <option value="Edit"> Edit Checked Items </option>
      <option value="Move"> Move Checked Items </option>
      <option value="Copy"> Copy Checked Items </option>
      <option value="Delete"> Delete Checked Items </option>
    </select> <input type="submit" value="Submit" name="B1"
    style="font-family: MS Sans Serif; font-size: 8pt"
    onClick="submitForm(document.select_all,0); return false;"> <a
    href="javascript:checkall('select_all',true)">Check All </a>| <a
    href="javascript:checkall('select_all',false)">UnCheck All </a><br>
    <br>
    $page_crit $pgstring </td>
  </tr>
</table>

<hr noshade size="1" color="#F2F2F2">

</form>
<BR>

</body>
</html>

];


#print "--> $pgstring <BR><BR>";
#print "--> $page_crit <BR><BR>";
#print $all_links;



}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

